<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>9.6. random — Generate pseudo-random numbers &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="9. Numeric and Mathematical Modules" href="numeric.html" />
    <link rel="next" title="9.7. statistics — Mathematical statistics functions" href="statistics.html" />
    <link rel="prev" title="9.5. fractions — Rational numbers" href="fractions.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="statistics.html" title="9.7. statistics — Mathematical statistics functions"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="fractions.html" title="9.5. fractions — Rational numbers"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="numeric.html" accesskey="U">9. Numeric and Mathematical Modules</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-random">
<span id="random-generate-pseudo-random-numbers"></span><h1>9.6. <a class="reference internal" href="#module-random" title="random: Generate pseudo-random numbers with various common distributions."><code class="xref py py-mod docutils literal"><span class="pre">random</span></code></a> &#8212; Generate pseudo-random numbers<a class="headerlink" href="#module-random" title="Permalink to this headline">¶</a></h1>
<p><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/random.py">Lib/random.py</a></p>
<hr class="docutils" />
<p>This module implements pseudo-random number generators for various
distributions.</p>
<p>For integers, there is uniform selection from a range. For sequences, there is
uniform selection of a random element, a function to generate a random
permutation of a list in-place, and a function for random sampling without
replacement.</p>
<p>On the real line, there are functions to compute uniform, normal (Gaussian),
lognormal, negative exponential, gamma, and beta distributions. For generating
distributions of angles, the von Mises distribution is available.</p>
<p>Almost all module functions depend on the basic function <a class="reference internal" href="#module-random" title="random: Generate pseudo-random numbers with various common distributions."><code class="xref py py-func docutils literal"><span class="pre">random()</span></code></a>, which
generates a random float uniformly in the semi-open range [0.0, 1.0).  Python
uses the Mersenne Twister as the core generator.  It produces 53-bit precision
floats and has a period of 2**19937-1.  The underlying implementation in C is
both fast and threadsafe.  The Mersenne Twister is one of the most extensively
tested random number generators in existence.  However, being completely
deterministic, it is not suitable for all purposes, and is completely unsuitable
for cryptographic purposes.</p>
<p>The functions supplied by this module are actually bound methods of a hidden
instance of the <code class="xref py py-class docutils literal"><span class="pre">random.Random</span></code> class.  You can instantiate your own
instances of <code class="xref py py-class docutils literal"><span class="pre">Random</span></code> to get generators that don&#8217;t share state.</p>
<p>Class <code class="xref py py-class docutils literal"><span class="pre">Random</span></code> can also be subclassed if you want to use a different
basic generator of your own devising: in that case, override the <a class="reference internal" href="#module-random" title="random: Generate pseudo-random numbers with various common distributions."><code class="xref py py-meth docutils literal"><span class="pre">random()</span></code></a>,
<a class="reference internal" href="#random.seed" title="random.seed"><code class="xref py py-meth docutils literal"><span class="pre">seed()</span></code></a>, <a class="reference internal" href="#random.getstate" title="random.getstate"><code class="xref py py-meth docutils literal"><span class="pre">getstate()</span></code></a>, and <a class="reference internal" href="#random.setstate" title="random.setstate"><code class="xref py py-meth docutils literal"><span class="pre">setstate()</span></code></a> methods.
Optionally, a new generator can supply a <a class="reference internal" href="#random.getrandbits" title="random.getrandbits"><code class="xref py py-meth docutils literal"><span class="pre">getrandbits()</span></code></a> method &#8212; this
allows <a class="reference internal" href="#random.randrange" title="random.randrange"><code class="xref py py-meth docutils literal"><span class="pre">randrange()</span></code></a> to produce selections over an arbitrarily large range.</p>
<p>The <a class="reference internal" href="#module-random" title="random: Generate pseudo-random numbers with various common distributions."><code class="xref py py-mod docutils literal"><span class="pre">random</span></code></a> module also provides the <a class="reference internal" href="#random.SystemRandom" title="random.SystemRandom"><code class="xref py py-class docutils literal"><span class="pre">SystemRandom</span></code></a> class which
uses the system function <a class="reference internal" href="os.html#os.urandom" title="os.urandom"><code class="xref py py-func docutils literal"><span class="pre">os.urandom()</span></code></a> to generate random numbers
from sources provided by the operating system.</p>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">The pseudo-random generators of this module should not be used for
security purposes.</p>
</div>
<p>Bookkeeping functions:</p>
<dl class="function">
<dt id="random.seed">
<code class="descclassname">random.</code><code class="descname">seed</code><span class="sig-paren">(</span><em>a=None</em>, <em>version=2</em><span class="sig-paren">)</span><a class="headerlink" href="#random.seed" title="Permalink to this definition">¶</a></dt>
<dd><p>Initialize the random number generator.</p>
<p>If <em>a</em> is omitted or <code class="docutils literal"><span class="pre">None</span></code>, the current system time is used.  If
randomness sources are provided by the operating system, they are used
instead of the system time (see the <a class="reference internal" href="os.html#os.urandom" title="os.urandom"><code class="xref py py-func docutils literal"><span class="pre">os.urandom()</span></code></a> function for details
on availability).</p>
<p>If <em>a</em> is an int, it is used directly.</p>
<p>With version 2 (the default), a <a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a>, <a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a>, or <a class="reference internal" href="functions.html#bytearray" title="bytearray"><code class="xref py py-class docutils literal"><span class="pre">bytearray</span></code></a>
object gets converted to an <a class="reference internal" href="functions.html#int" title="int"><code class="xref py py-class docutils literal"><span class="pre">int</span></code></a> and all of its bits are used.  With version 1,
the <a class="reference internal" href="functions.html#hash" title="hash"><code class="xref py py-func docutils literal"><span class="pre">hash()</span></code></a> of <em>a</em> is used instead.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span>Moved to the version 2 scheme which uses all of the bits in a string seed.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="random.getstate">
<code class="descclassname">random.</code><code class="descname">getstate</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#random.getstate" title="Permalink to this definition">¶</a></dt>
<dd><p>Return an object capturing the current internal state of the generator.  This
object can be passed to <a class="reference internal" href="#random.setstate" title="random.setstate"><code class="xref py py-func docutils literal"><span class="pre">setstate()</span></code></a> to restore the state.</p>
</dd></dl>

<dl class="function">
<dt id="random.setstate">
<code class="descclassname">random.</code><code class="descname">setstate</code><span class="sig-paren">(</span><em>state</em><span class="sig-paren">)</span><a class="headerlink" href="#random.setstate" title="Permalink to this definition">¶</a></dt>
<dd><p><em>state</em> should have been obtained from a previous call to <a class="reference internal" href="#random.getstate" title="random.getstate"><code class="xref py py-func docutils literal"><span class="pre">getstate()</span></code></a>, and
<a class="reference internal" href="#random.setstate" title="random.setstate"><code class="xref py py-func docutils literal"><span class="pre">setstate()</span></code></a> restores the internal state of the generator to what it was at
the time <a class="reference internal" href="#random.getstate" title="random.getstate"><code class="xref py py-func docutils literal"><span class="pre">getstate()</span></code></a> was called.</p>
</dd></dl>

<dl class="function">
<dt id="random.getrandbits">
<code class="descclassname">random.</code><code class="descname">getrandbits</code><span class="sig-paren">(</span><em>k</em><span class="sig-paren">)</span><a class="headerlink" href="#random.getrandbits" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns a Python integer with <em>k</em> random bits. This method is supplied with
the MersenneTwister generator and some other generators may also provide it
as an optional part of the API. When available, <a class="reference internal" href="#random.getrandbits" title="random.getrandbits"><code class="xref py py-meth docutils literal"><span class="pre">getrandbits()</span></code></a> enables
<a class="reference internal" href="#random.randrange" title="random.randrange"><code class="xref py py-meth docutils literal"><span class="pre">randrange()</span></code></a> to handle arbitrarily large ranges.</p>
</dd></dl>

<p>Functions for integers:</p>
<dl class="function">
<dt id="random.randrange">
<code class="descclassname">random.</code><code class="descname">randrange</code><span class="sig-paren">(</span><em>stop</em><span class="sig-paren">)</span><a class="headerlink" href="#random.randrange" title="Permalink to this definition">¶</a></dt>
<dt>
<code class="descclassname">random.</code><code class="descname">randrange</code><span class="sig-paren">(</span><em>start</em>, <em>stop</em><span class="optional">[</span>, <em>step</em><span class="optional">]</span><span class="sig-paren">)</span></dt>
<dd><p>Return a randomly selected element from <code class="docutils literal"><span class="pre">range(start,</span> <span class="pre">stop,</span> <span class="pre">step)</span></code>.  This is
equivalent to <code class="docutils literal"><span class="pre">choice(range(start,</span> <span class="pre">stop,</span> <span class="pre">step))</span></code>, but doesn&#8217;t actually build a
range object.</p>
<p>The positional argument pattern matches that of <a class="reference internal" href="stdtypes.html#range" title="range"><code class="xref py py-func docutils literal"><span class="pre">range()</span></code></a>.  Keyword arguments
should not be used because the function may use them in unexpected ways.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span><a class="reference internal" href="#random.randrange" title="random.randrange"><code class="xref py py-meth docutils literal"><span class="pre">randrange()</span></code></a> is more sophisticated about producing equally distributed
values.  Formerly it used a style like <code class="docutils literal"><span class="pre">int(random()*n)</span></code> which could produce
slightly uneven distributions.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="random.randint">
<code class="descclassname">random.</code><code class="descname">randint</code><span class="sig-paren">(</span><em>a</em>, <em>b</em><span class="sig-paren">)</span><a class="headerlink" href="#random.randint" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a random integer <em>N</em> such that <code class="docutils literal"><span class="pre">a</span> <span class="pre">&lt;=</span> <span class="pre">N</span> <span class="pre">&lt;=</span> <span class="pre">b</span></code>.  Alias for
<code class="docutils literal"><span class="pre">randrange(a,</span> <span class="pre">b+1)</span></code>.</p>
</dd></dl>

<p>Functions for sequences:</p>
<dl class="function">
<dt id="random.choice">
<code class="descclassname">random.</code><code class="descname">choice</code><span class="sig-paren">(</span><em>seq</em><span class="sig-paren">)</span><a class="headerlink" href="#random.choice" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a random element from the non-empty sequence <em>seq</em>. If <em>seq</em> is empty,
raises <a class="reference internal" href="exceptions.html#IndexError" title="IndexError"><code class="xref py py-exc docutils literal"><span class="pre">IndexError</span></code></a>.</p>
</dd></dl>

<dl class="function">
<dt id="random.shuffle">
<code class="descclassname">random.</code><code class="descname">shuffle</code><span class="sig-paren">(</span><em>x</em><span class="optional">[</span>, <em>random</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#random.shuffle" title="Permalink to this definition">¶</a></dt>
<dd><p>Shuffle the sequence <em>x</em> in place. The optional argument <em>random</em> is a
0-argument function returning a random float in [0.0, 1.0); by default, this is
the function <a class="reference internal" href="#module-random" title="random: Generate pseudo-random numbers with various common distributions."><code class="xref py py-func docutils literal"><span class="pre">random()</span></code></a>.</p>
<p>Note that for even rather small <code class="docutils literal"><span class="pre">len(x)</span></code>, the total number of permutations of
<em>x</em> is larger than the period of most random number generators; this implies
that most permutations of a long sequence can never be generated.</p>
</dd></dl>

<dl class="function">
<dt id="random.sample">
<code class="descclassname">random.</code><code class="descname">sample</code><span class="sig-paren">(</span><em>population</em>, <em>k</em><span class="sig-paren">)</span><a class="headerlink" href="#random.sample" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a <em>k</em> length list of unique elements chosen from the population sequence
or set. Used for random sampling without replacement.</p>
<p>Returns a new list containing elements from the population while leaving the
original population unchanged.  The resulting list is in selection order so that
all sub-slices will also be valid random samples.  This allows raffle winners
(the sample) to be partitioned into grand prize and second place winners (the
subslices).</p>
<p>Members of the population need not be <a class="reference internal" href="../glossary.html#term-hashable"><span class="xref std std-term">hashable</span></a> or unique.  If the population
contains repeats, then each occurrence is a possible selection in the sample.</p>
<p>To choose a sample from a range of integers, use an <a class="reference internal" href="stdtypes.html#range" title="range"><code class="xref py py-func docutils literal"><span class="pre">range()</span></code></a> object as an
argument.  This is especially fast and space efficient for sampling from a large
population:  <code class="docutils literal"><span class="pre">sample(range(10000000),</span> <span class="pre">60)</span></code>.</p>
<p>If the sample size is larger than the population size, a <a class="reference internal" href="exceptions.html#ValueError" title="ValueError"><code class="xref py py-exc docutils literal"><span class="pre">ValueError</span></code></a>
is raised.</p>
</dd></dl>

<p>The following functions generate specific real-valued distributions. Function
parameters are named after the corresponding variables in the distribution&#8217;s
equation, as used in common mathematical practice; most of these equations can
be found in any statistics text.</p>
<dl class="function">
<dt id="random.random">
<code class="descclassname">random.</code><code class="descname">random</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#random.random" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the next random floating point number in the range [0.0, 1.0).</p>
</dd></dl>

<dl class="function">
<dt id="random.uniform">
<code class="descclassname">random.</code><code class="descname">uniform</code><span class="sig-paren">(</span><em>a</em>, <em>b</em><span class="sig-paren">)</span><a class="headerlink" href="#random.uniform" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a random floating point number <em>N</em> such that <code class="docutils literal"><span class="pre">a</span> <span class="pre">&lt;=</span> <span class="pre">N</span> <span class="pre">&lt;=</span> <span class="pre">b</span></code> for
<code class="docutils literal"><span class="pre">a</span> <span class="pre">&lt;=</span> <span class="pre">b</span></code> and <code class="docutils literal"><span class="pre">b</span> <span class="pre">&lt;=</span> <span class="pre">N</span> <span class="pre">&lt;=</span> <span class="pre">a</span></code> for <code class="docutils literal"><span class="pre">b</span> <span class="pre">&lt;</span> <span class="pre">a</span></code>.</p>
<p>The end-point value <code class="docutils literal"><span class="pre">b</span></code> may or may not be included in the range
depending on floating-point rounding in the equation <code class="docutils literal"><span class="pre">a</span> <span class="pre">+</span> <span class="pre">(b-a)</span> <span class="pre">*</span> <span class="pre">random()</span></code>.</p>
</dd></dl>

<dl class="function">
<dt id="random.triangular">
<code class="descclassname">random.</code><code class="descname">triangular</code><span class="sig-paren">(</span><em>low</em>, <em>high</em>, <em>mode</em><span class="sig-paren">)</span><a class="headerlink" href="#random.triangular" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a random floating point number <em>N</em> such that <code class="docutils literal"><span class="pre">low</span> <span class="pre">&lt;=</span> <span class="pre">N</span> <span class="pre">&lt;=</span> <span class="pre">high</span></code> and
with the specified <em>mode</em> between those bounds.  The <em>low</em> and <em>high</em> bounds
default to zero and one.  The <em>mode</em> argument defaults to the midpoint
between the bounds, giving a symmetric distribution.</p>
</dd></dl>

<dl class="function">
<dt id="random.betavariate">
<code class="descclassname">random.</code><code class="descname">betavariate</code><span class="sig-paren">(</span><em>alpha</em>, <em>beta</em><span class="sig-paren">)</span><a class="headerlink" href="#random.betavariate" title="Permalink to this definition">¶</a></dt>
<dd><p>Beta distribution.  Conditions on the parameters are <code class="docutils literal"><span class="pre">alpha</span> <span class="pre">&gt;</span> <span class="pre">0</span></code> and
<code class="docutils literal"><span class="pre">beta</span> <span class="pre">&gt;</span> <span class="pre">0</span></code>. Returned values range between 0 and 1.</p>
</dd></dl>

<dl class="function">
<dt id="random.expovariate">
<code class="descclassname">random.</code><code class="descname">expovariate</code><span class="sig-paren">(</span><em>lambd</em><span class="sig-paren">)</span><a class="headerlink" href="#random.expovariate" title="Permalink to this definition">¶</a></dt>
<dd><p>Exponential distribution.  <em>lambd</em> is 1.0 divided by the desired
mean.  It should be nonzero.  (The parameter would be called
&#8220;lambda&#8221;, but that is a reserved word in Python.)  Returned values
range from 0 to positive infinity if <em>lambd</em> is positive, and from
negative infinity to 0 if <em>lambd</em> is negative.</p>
</dd></dl>

<dl class="function">
<dt id="random.gammavariate">
<code class="descclassname">random.</code><code class="descname">gammavariate</code><span class="sig-paren">(</span><em>alpha</em>, <em>beta</em><span class="sig-paren">)</span><a class="headerlink" href="#random.gammavariate" title="Permalink to this definition">¶</a></dt>
<dd><p>Gamma distribution.  (<em>Not</em> the gamma function!)  Conditions on the
parameters are <code class="docutils literal"><span class="pre">alpha</span> <span class="pre">&gt;</span> <span class="pre">0</span></code> and <code class="docutils literal"><span class="pre">beta</span> <span class="pre">&gt;</span> <span class="pre">0</span></code>.</p>
<p>The probability distribution function is:</p>
<div class="highlight-python3"><div class="highlight"><pre>          <span class="n">x</span> <span class="o">**</span> <span class="p">(</span><span class="n">alpha</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span> <span class="o">*</span> <span class="n">math</span><span class="o">.</span><span class="n">exp</span><span class="p">(</span><span class="o">-</span><span class="n">x</span> <span class="o">/</span> <span class="n">beta</span><span class="p">)</span>
<span class="n">pdf</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="o">=</span>  <span class="o">--------------------------------------</span>
            <span class="n">math</span><span class="o">.</span><span class="n">gamma</span><span class="p">(</span><span class="n">alpha</span><span class="p">)</span> <span class="o">*</span> <span class="n">beta</span> <span class="o">**</span> <span class="n">alpha</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="random.gauss">
<code class="descclassname">random.</code><code class="descname">gauss</code><span class="sig-paren">(</span><em>mu</em>, <em>sigma</em><span class="sig-paren">)</span><a class="headerlink" href="#random.gauss" title="Permalink to this definition">¶</a></dt>
<dd><p>Gaussian distribution.  <em>mu</em> is the mean, and <em>sigma</em> is the standard
deviation.  This is slightly faster than the <a class="reference internal" href="#random.normalvariate" title="random.normalvariate"><code class="xref py py-func docutils literal"><span class="pre">normalvariate()</span></code></a> function
defined below.</p>
</dd></dl>

<dl class="function">
<dt id="random.lognormvariate">
<code class="descclassname">random.</code><code class="descname">lognormvariate</code><span class="sig-paren">(</span><em>mu</em>, <em>sigma</em><span class="sig-paren">)</span><a class="headerlink" href="#random.lognormvariate" title="Permalink to this definition">¶</a></dt>
<dd><p>Log normal distribution.  If you take the natural logarithm of this
distribution, you&#8217;ll get a normal distribution with mean <em>mu</em> and standard
deviation <em>sigma</em>.  <em>mu</em> can have any value, and <em>sigma</em> must be greater than
zero.</p>
</dd></dl>

<dl class="function">
<dt id="random.normalvariate">
<code class="descclassname">random.</code><code class="descname">normalvariate</code><span class="sig-paren">(</span><em>mu</em>, <em>sigma</em><span class="sig-paren">)</span><a class="headerlink" href="#random.normalvariate" title="Permalink to this definition">¶</a></dt>
<dd><p>Normal distribution.  <em>mu</em> is the mean, and <em>sigma</em> is the standard deviation.</p>
</dd></dl>

<dl class="function">
<dt id="random.vonmisesvariate">
<code class="descclassname">random.</code><code class="descname">vonmisesvariate</code><span class="sig-paren">(</span><em>mu</em>, <em>kappa</em><span class="sig-paren">)</span><a class="headerlink" href="#random.vonmisesvariate" title="Permalink to this definition">¶</a></dt>
<dd><p><em>mu</em> is the mean angle, expressed in radians between 0 and 2*<em>pi</em>, and <em>kappa</em>
is the concentration parameter, which must be greater than or equal to zero.  If
<em>kappa</em> is equal to zero, this distribution reduces to a uniform random angle
over the range 0 to 2*<em>pi</em>.</p>
</dd></dl>

<dl class="function">
<dt id="random.paretovariate">
<code class="descclassname">random.</code><code class="descname">paretovariate</code><span class="sig-paren">(</span><em>alpha</em><span class="sig-paren">)</span><a class="headerlink" href="#random.paretovariate" title="Permalink to this definition">¶</a></dt>
<dd><p>Pareto distribution.  <em>alpha</em> is the shape parameter.</p>
</dd></dl>

<dl class="function">
<dt id="random.weibullvariate">
<code class="descclassname">random.</code><code class="descname">weibullvariate</code><span class="sig-paren">(</span><em>alpha</em>, <em>beta</em><span class="sig-paren">)</span><a class="headerlink" href="#random.weibullvariate" title="Permalink to this definition">¶</a></dt>
<dd><p>Weibull distribution.  <em>alpha</em> is the scale parameter and <em>beta</em> is the shape
parameter.</p>
</dd></dl>

<p>Alternative Generator:</p>
<dl class="class">
<dt id="random.SystemRandom">
<em class="property">class </em><code class="descclassname">random.</code><code class="descname">SystemRandom</code><span class="sig-paren">(</span><span class="optional">[</span><em>seed</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#random.SystemRandom" title="Permalink to this definition">¶</a></dt>
<dd><p>Class that uses the <a class="reference internal" href="os.html#os.urandom" title="os.urandom"><code class="xref py py-func docutils literal"><span class="pre">os.urandom()</span></code></a> function for generating random numbers
from sources provided by the operating system. Not available on all systems.
Does not rely on software state, and sequences are not reproducible. Accordingly,
the <a class="reference internal" href="#random.seed" title="random.seed"><code class="xref py py-meth docutils literal"><span class="pre">seed()</span></code></a> method has no effect and is ignored.
The <a class="reference internal" href="#random.getstate" title="random.getstate"><code class="xref py py-meth docutils literal"><span class="pre">getstate()</span></code></a> and <a class="reference internal" href="#random.setstate" title="random.setstate"><code class="xref py py-meth docutils literal"><span class="pre">setstate()</span></code></a> methods raise
<a class="reference internal" href="exceptions.html#NotImplementedError" title="NotImplementedError"><code class="xref py py-exc docutils literal"><span class="pre">NotImplementedError</span></code></a> if called.</p>
</dd></dl>

<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<p>M. Matsumoto and T. Nishimura, &#8220;Mersenne Twister: A 623-dimensionally
equidistributed uniform pseudorandom number generator&#8221;, ACM Transactions on
Modeling and Computer Simulation Vol. 8, No. 1, January pp.3-30 1998.</p>
<p class="last"><a class="reference external" href="http://code.activestate.com/recipes/576707/">Complementary-Multiply-with-Carry recipe</a> for a compatible alternative
random number generator with a long period and comparatively simple update
operations.</p>
</div>
<div class="section" id="notes-on-reproducibility">
<h2>9.6.1. Notes on Reproducibility<a class="headerlink" href="#notes-on-reproducibility" title="Permalink to this headline">¶</a></h2>
<p>Sometimes it is useful to be able to reproduce the sequences given by a pseudo
random number generator.  By re-using a seed value, the same sequence should be
reproducible from run to run as long as multiple threads are not running.</p>
<p>Most of the random module&#8217;s algorithms and seeding functions are subject to
change across Python versions, but two aspects are guaranteed not to change:</p>
<ul class="simple">
<li>If a new seeding method is added, then a backward compatible seeder will be
offered.</li>
<li>The generator&#8217;s <a class="reference internal" href="#module-random" title="random: Generate pseudo-random numbers with various common distributions."><code class="xref py py-meth docutils literal"><span class="pre">random()</span></code></a> method will continue to produce the same
sequence when the compatible seeder is given the same seed.</li>
</ul>
</div>
<div class="section" id="examples-and-recipes">
<span id="random-examples"></span><h2>9.6.2. Examples and Recipes<a class="headerlink" href="#examples-and-recipes" title="Permalink to this headline">¶</a></h2>
<p>Basic usage:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">random</span><span class="o">.</span><span class="n">random</span><span class="p">()</span>                      <span class="c"># Random float x, 0.0 &lt;= x &lt; 1.0</span>
<span class="go">0.37444887175646646</span>

<span class="gp">&gt;&gt;&gt; </span><span class="n">random</span><span class="o">.</span><span class="n">uniform</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">10</span><span class="p">)</span>                <span class="c"># Random float x, 1.0 &lt;= x &lt; 10.0</span>
<span class="go">1.1800146073117523</span>

<span class="gp">&gt;&gt;&gt; </span><span class="n">random</span><span class="o">.</span><span class="n">randrange</span><span class="p">(</span><span class="mi">10</span><span class="p">)</span>                 <span class="c"># Integer from 0 to 9</span>
<span class="go">7</span>

<span class="gp">&gt;&gt;&gt; </span><span class="n">random</span><span class="o">.</span><span class="n">randrange</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">101</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>          <span class="c"># Even integer from 0 to 100</span>
<span class="go">26</span>

<span class="gp">&gt;&gt;&gt; </span><span class="n">random</span><span class="o">.</span><span class="n">choice</span><span class="p">(</span><span class="s">&#39;abcdefghij&#39;</span><span class="p">)</span>          <span class="c"># Single random element</span>
<span class="go">&#39;c&#39;</span>

<span class="gp">&gt;&gt;&gt; </span><span class="n">items</span> <span class="o">=</span> <span class="p">[</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">6</span><span class="p">,</span> <span class="mi">7</span><span class="p">]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">random</span><span class="o">.</span><span class="n">shuffle</span><span class="p">(</span><span class="n">items</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">items</span>
<span class="go">[7, 3, 2, 5, 6, 4, 1]</span>

<span class="gp">&gt;&gt;&gt; </span><span class="n">random</span><span class="o">.</span><span class="n">sample</span><span class="p">([</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">4</span><span class="p">,</span> <span class="mi">5</span><span class="p">],</span>  <span class="mi">3</span><span class="p">)</span>   <span class="c"># Three samples without replacement</span>
<span class="go">[4, 1, 5]</span>
</pre></div>
</div>
<p>A common task is to make a <a class="reference internal" href="#random.choice" title="random.choice"><code class="xref py py-func docutils literal"><span class="pre">random.choice()</span></code></a> with weighted probabilities.</p>
<p>If the weights are small integer ratios, a simple technique is to build a sample
population with repeats:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">weighted_choices</span> <span class="o">=</span> <span class="p">[(</span><span class="s">&#39;Red&#39;</span><span class="p">,</span> <span class="mi">3</span><span class="p">),</span> <span class="p">(</span><span class="s">&#39;Blue&#39;</span><span class="p">,</span> <span class="mi">2</span><span class="p">),</span> <span class="p">(</span><span class="s">&#39;Yellow&#39;</span><span class="p">,</span> <span class="mi">1</span><span class="p">),</span> <span class="p">(</span><span class="s">&#39;Green&#39;</span><span class="p">,</span> <span class="mi">4</span><span class="p">)]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">population</span> <span class="o">=</span> <span class="p">[</span><span class="n">val</span> <span class="k">for</span> <span class="n">val</span><span class="p">,</span> <span class="n">cnt</span> <span class="ow">in</span> <span class="n">weighted_choices</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">cnt</span><span class="p">)]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">random</span><span class="o">.</span><span class="n">choice</span><span class="p">(</span><span class="n">population</span><span class="p">)</span>
<span class="go">&#39;Green&#39;</span>
</pre></div>
</div>
<p>A more general approach is to arrange the weights in a cumulative distribution
with <a class="reference internal" href="itertools.html#itertools.accumulate" title="itertools.accumulate"><code class="xref py py-func docutils literal"><span class="pre">itertools.accumulate()</span></code></a>, and then locate the random value with
<a class="reference internal" href="bisect.html#bisect.bisect" title="bisect.bisect"><code class="xref py py-func docutils literal"><span class="pre">bisect.bisect()</span></code></a>:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">choices</span><span class="p">,</span> <span class="n">weights</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">weighted_choices</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">cumdist</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">itertools</span><span class="o">.</span><span class="n">accumulate</span><span class="p">(</span><span class="n">weights</span><span class="p">))</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">x</span> <span class="o">=</span> <span class="n">random</span><span class="o">.</span><span class="n">random</span><span class="p">()</span> <span class="o">*</span> <span class="n">cumdist</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">choices</span><span class="p">[</span><span class="n">bisect</span><span class="o">.</span><span class="n">bisect</span><span class="p">(</span><span class="n">cumdist</span><span class="p">,</span> <span class="n">x</span><span class="p">)]</span>
<span class="go">&#39;Blue&#39;</span>
</pre></div>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">9.6. <code class="docutils literal"><span class="pre">random</span></code> &#8212; Generate pseudo-random numbers</a><ul>
<li><a class="reference internal" href="#notes-on-reproducibility">9.6.1. Notes on Reproducibility</a></li>
<li><a class="reference internal" href="#examples-and-recipes">9.6.2. Examples and Recipes</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="fractions.html"
                        title="previous chapter">9.5. <code class="docutils literal"><span class="pre">fractions</span></code> &#8212; Rational numbers</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="statistics.html"
                        title="next chapter">9.7. <code class="docutils literal"><span class="pre">statistics</span></code> &#8212; Mathematical statistics functions</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/random.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="statistics.html" title="9.7. statistics — Mathematical statistics functions"
             >next</a> |</li>
        <li class="right" >
          <a href="fractions.html" title="9.5. fractions — Rational numbers"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="numeric.html" >9. Numeric and Mathematical Modules</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>